IMAGE_INFOS					STRUCT
	hImage					HBITMAP			?
	Image					BITMAP			<>
	ImageInfo				BITMAPINFO		<>
	ImageSens				DWord			?			; Sens de l'image
	dwImageRatio			REAL10			?
	dwImageData				DWord			?
	lpImageBits				LPBYTE			?
IMAGE_INFOS					ENDS

LPIMAGE_INFOS	TYPEDEF	PTR IMAGE_INFOS

;	========================================================================================================================
							.Code
;	========================================================================================================================

;	================================================================================
;	This function get bitmaps bits from a HBITMAP handle.
;	The result is a buffer returned in EAX
;	In EAX is a pointer to an IMAGE_INFOS structure. The __hBitmap parameter is released.
;	If the function fails EAX is NULL
;	EBX EDI and ESI are preserved
;	================================================================================

GFL_GetBitsFromHandle			PROC	USES EBX EDI ESI,__hBitmap:HBITMAP
								LOCAL	_TmpImageInfos:IMAGE_INFOS
								LOCAL	_Bitmap:BITMAP

								INVOKE	GetObject,__hBitmap,SIZEOF BITMAP,ADDR _Bitmap

								mov		eax,DWord Ptr _Bitmap.bmWidth
								lea		edi,_TmpImageInfos

								cmp		eax,DWord Ptr _Bitmap.bmHeight
								jg		@Horizontale

								push	IMAGE_VERTICALE

								fild	DWord Ptr _Bitmap.bmWidth
								fidiv	DWord Ptr _Bitmap.bmHeight

								jmp		@Continue

@Horizontale :

								push	IMAGE_HORIZONTALE

								fild	DWord Ptr _Bitmap.bmHeight
								fidiv	DWord Ptr _Bitmap.bmWidth

@Continue :

								fst		QWord Ptr (IMAGE_INFOS Ptr [edi]).dImageRatio
								pop		(IMAGE_INFOS Ptr [edi]).dwImageSens

								mov		DWord Ptr (IMAGE_INFOS Ptr [edi]).Image.biSize,SIZEOF BITMAPINFOHEADER
								mov		DWord Ptr (IMAGE_INFOS Ptr [edi]).Image.biPlanes,1
								mov		DWord Ptr (IMAGE_INFOS Ptr [edi]).Image.biCompression,BI_RGB

								push	DWord Ptr _Bitmap.bmWidth
								pop		DWord Ptr (IMAGE_INFOS Ptr [edi]).Image.biWidth

								push	DWord Ptr _Bitmap.bmHeight
								xor		eax,eax
								pop		DWord Ptr (IMAGE_INFOS Ptr [edi]).Image.biHeight

								mov		ax,Word Ptr _Bitmap.bmBitsPixel
								mov		Word Ptr (IMAGE_INFOS Ptr [edi]).Image.biBitCount,ax

								INVOKE	GetDC,NULL

								test	eax,eax
								jz		@Exit

									mov		esi,eax

									INVOKE	GetDIBits,esi,__hBitmap,0,_Bitmap.bmHeight,NULL,ADDR _TmpImageInfos.Image,DIB_RGB_COLORS

									mov		eax,(IMAGE_INFOS Ptr [edi]).Image.biSizeImage
									mov		(IMAGE_INFOS Ptr [edi]).dwImageData,DATA_IMAGES
									mov		(IMAGE_INFOS Ptr [edi]).dwImageSize,eax

									add		eax,SIZEOF IMAGE_INFOS
									mov		(IMAGE_INFOS Ptr [edi]).dwTotalDatasSize,eax

									INVOKE	Memory_Alloc,eax
									jz		@Error_0

										INVOKE	MemCopy,eax,edi,SIZEOF IMAGE_INFOS

										mov		edi,eax
										add		eax,SIZEOF IMAGE_INFOS
										mov		(IMAGE_INFOS Ptr [edi]).lpImageBits,eax

										INVOKE	GetDIBits,esi,__hBitmap,0,_Bitmap.bmHeight,(IMAGE_INFOS Ptr [edi]).lpImageBits,ADDR (IMAGE_INFOS Ptr [edi]).Image,DIB_RGB_COLORS

										test	eax,eax
										jz		@Error_1

											INVOKE	DeleteObject,__hBitmap
											INVOKE	ReleaseDC,NULL,esi

											mov		eax,edi

											test	eax,eax
											jmp		@Exit

@Error_1 :						INVOKE	Memory_Free,edi
@Error_0 :						INVOKE	ReleaseDC,NULL,esi
@Error :						xor		eax,eax

@Exit :

								ret
GFL_GetBitsFromHandle			ENDP

;	================================================================================
